const int RED = 9;
const int GREEN = 10;
const int BLUE = 11;
int incomingByte;  //BYTE RECEIVED FROM SERIAL PORT

void setup() {
  //SETUP SERIAL
  pinMode(0,INPUT);  //SERIAL INPUT ON PIN 0 (RX)
  pinMode(1,OUTPUT);  //SERIAL OUTPUT ON PIN 1 (TX)
  Serial.begin(9600);

  //SET ARDUINO R,G,B PINS FOR OUTPUT
  pinMode(RED,OUTPUT);
  pinMode(GREEN,OUTPUT);
  pinMode(BLUE,OUTPUT);

  //DO A LITTLE LIGHT SHOW WHEN STARTING
  CrossFade(0,0,0,0,0,255,5000);  //OFF TO BLUE
  LightShow(4000);  //ONCE SLOW
  LightShow(2000);  //ONCE MEDIUM
  LightShow(1000);  //ONCE FAST
  LightShow(1000);  //SECOND TIME FAST
  CrossFade(0,0,255,0,0,0,1000);  //BLUE TO OFF
}

void loop() {
  /*************************************************************
   * B - Building
   * S - Successful build - Future S[,mp3 filename]
   * F - Failed build - Future F[,mp3 filename]
   * C,RRR,GGG,BBB - display a Color
   * O - Off
   * P,mp3 filename - Play mp3 (Future)
   * X,RRR,GGG,BBB,RRR,GGG,BBB,tttt - cross fade color to color
   * L - Light show
   *************************************************************/

  if (Serial.available() > 0) {

    incomingByte = Serial.read(); 

    switch (char(incomingByte)) {
    case 'B':  //BUILDING
      Building();
      break;
    case 'S':  //SUCCESSFUL BUILD
      SuccessfulBuild();
      break;
    case 'F':  //FAILED BUILD
      FailedBuild();
      break;
    case 'C':  //DISPLAY A COLOR
      delay(50);  //DELAY TO ALLOW THE DATA TO BE SENT
      SetColor(GetNumberFromSerial(3),GetNumberFromSerial(3),GetNumberFromSerial(3));
      break;
    case 'O':  //ORB OFF
      SetColor(0,0,0);
      Serial.flush();
      break;
    case 'P':  //PLAY MP3
      delay(50);  //DELAY TO ALLOW THE DATA TO BE SENT
      PlayMP3();
      break;
    case 'X':  //CROSS FADE
      delay(50);  //DELAY TO ALLOW THE DATA TO BE SENT
      CrossFade(GetNumberFromSerial(3),GetNumberFromSerial(3),GetNumberFromSerial(3),GetNumberFromSerial(3),GetNumberFromSerial(3),GetNumberFromSerial(3),GetNumberFromSerial(4));
      break;
    case 'L':  //LIGHT SHOW
      CrossFade(0,0,0,0,0,255,5000);  //OFF TO BLUE
      LightShow(5000);
      CrossFade(0,0,255,0,0,0,5000);  //BLUE TO OFF
      break;
    default:  //UNHANDLED
      Serial.flush();
    }
  }
}

