/*
 * When this sub is called, there should be a comma and a number in the serial buffer
 */

long GetNumberFromSerial(int digits) {

  long multiplier;
  long value;

  multiplier = 0.5 + pow(10,digits-1);
  value = 0;

  delay(10); //10 MILLISECOND DELAY TO ALLOW THE DATA TO BE SENT
  if (Serial.available() < (digits+1)) {  //NOT ENOUGH DIGITS IN SERIAL BUFFER
    Serial.flush();
  } 
  else 
  {
    incomingByte = Serial.read();
    if(char(incomingByte) != ',') {  //EXPECT THE COMMA
      Serial.flush();
      multiplier=0;
    } 
    else {  //READ THE VALUE
      while (multiplier >= 1) {
        delay(1); //1 MILLISECOND DELAY SO WE DON'T RUN OUT OF DATA BEFORE IT'S DONE BEING SENT
        incomingByte = Serial.read();
        value += (int(incomingByte)-int('0'))*multiplier;
        multiplier /= 10;
      }
    }
  }
  return value;
}

